 
#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "simBlockage.h"
#include <iostream.h>
#define  MAX(x,y)  ( ( (x) >= (y) ) ? (x) : (y) )

using namespace Rescue; 

//prototypes
int main2(int argc, char** argv);
void commands(S32& time, Input& input, Output& output, LongUDPSocket& socket, Address& to, ObjectPool& pool, ExtRoads difRoads, ExtRoads::const_iterator drit, ExtRoad* extrPtr);


int main(int argc, char** argv)
{
	try {
		return main2(argc, argv);
	} catch(std::exception& e) {
		fprintf(stderr, "%s\n", (const char*)e.what());
	} catch(...) {
		fprintf(stderr, "error...\n");
	}
	return 1;
  
}

int main2(int argc, char** argv)
{
	const char* host = "localhost";
	Config config;
 
	// 
	int i;
	int count = 0;
	for(i=1; i<argc; i++) {
		if(argv[i][0] == '-') {
			if(strcmp(argv[i], "-file") == 0) {
				if(++i < argc) {
					config.readConfigFile(argv[i]);
				} else {
					fprintf(stderr, "error: '-file'\n");
				}
			} else {
				if(++i < argc) {
					if(!config.setValue(argv[i-1]+1, argv[i]))
						fprintf(stderr, "error: '%s'\n", argv[i]);
				} else {
					fprintf(stderr, "error: '%s'\n", argv[i-1]);
				}
			}
		} else {
			switch(count++) {
			case 0:
				host = argv[i];
				break;
			default:
				fprintf(stderr, "error: '%s'\n", argv[i]);
				break;
			}
		}
	}

	// \Pbg쐬
	LongUDPSocket socket;
	Input input;
	Output output;
	output.setWait(config.send_udp_wait());
	Address to(host, config.port());	//M
  
  //////////////////////////////////////////
  //e錾
  TypeId type;
  //Id objId; //SIuWFNg̒ʂԍ
  Objects all; //ׂẴIuWFNg̃Xg  
  Objects::const_iterator oit;
  Objects::const_iterator suboit;
  Objects entranceList;
  Objects::const_iterator entit;
  Roads roads;
  Roads::const_iterator rit;
  Nodes nodes;
  Nodes::const_iterator nit;
  Buildings buildings;     
  Buildings::const_iterator bit;
  ExtRoads extRoads;  
  ExtRoads::const_iterator xrit;  
  ExtNodes extNodes;  
  ExtNodes::const_iterator xnit;  
  ExtRoads difRoads; //XV̂extRoad̃Xg  
  ExtRoads::const_iterator drit;
  
  Object* objPtr; //Objects^objectoĂɓ
  long int rNum = 0; //road̐
  long int subrNum =0; //P{orR{ȏroadqĂnoderoadڑ̑a
  long int brNum = 0; //number of blocked roads
  Road* rPtr;
  Node* nPtr;
  Building* bPtr;
  ExtRoad* extrPtr;
  ExtNode* extnPtr;
  short int shindo;  
  long int kscon = 0; //KS_CONNECT_OK𐔂
  long int kscom = 0; //KS_COMMANDS𐔂
  float parameter = 0.0; //RoboCupPʓH / fPʓH

  //kẍ̃vpeBݒ
  areaProperty area[4];
  areaProperty* areaPtr;
  areaPtr = area;
  initArea(areaPtr);

  //kẍ̒n}ǂݍ
  long int polyNum;
  long int pointNum;
  coordinates *polyPtr;
  polyPtr = getPoly(&polyNum, &pointNum, polyPtr);

 
	// ڑbZ[W𑗐M
	printf("connecting...\n");
	output.clear();								//o̓obt@ɂ
	output.put(SK_CONNECT);						//o̓obt@ SK_CONNECT (4oCg)o͂
	Output::Cursor base = output.put(~(S32)0);	//body ̃TCYƂĂƂ肠_~[̒lo͂ĂāAbase ɂ̈ʒuLB
  output.put(0);								//o̓obt@ 0 o͂
	output.setSize(base);						//base ŋLʒuɁAbase 炱܂ł put oCgݒ肷B
	output.put(HEADER_NULL);
	socket.send(output, to);					//output  put oCg to ֑MB

	// bZ[W[v
	S32 time = 0;
	ObjectPool pool;
	for(;;) {
		try {
			socket.receive(input);	// TODO: G[OŕԂ	//f[^MAinput ֒~B
			for(;;) {
				Header header = input.get();	//input (4oCg)f[^oAheader ֑
				if(header == HEADER_NULL)
					break;

				S32 size = input.get();
				Input::Cursor start = input.cursor();	//ݓǂݏoĂʒuL

        switch(header) {
				default:
					printf("Unknown header.\n");
					break;
				case KS_CONNECT_ERROR:
					printf("Connection failed.\n");
					return 1;
          ////////////////////////////////////////////////////start of case KS_CONNECT_OK
				case KS_CONNECT_OK:
          ++kscon;
					printf("Connect Ok %d.\n", kscon);
					to = socket.addressRecievedFrom();	//ȍ~̑MύX
					pool.restructure(0, input);			//[hfB
					// ack Ԃ
					output.clear();
					output.put(SK_ACKNOWLEDGE);
					output.put(~(S32)0);
					output.put(HEADER_NULL);
					socket.send(output, to);

          if (kscon == 2) //KS_CONNECT_OK͂Q󂯎KvȂ
            break;

          /////////////////////////////////////////////////////////
          //IuWFNgroads,nodesɎd
          all = pool.objects();
          oit = all.begin();

          for ( ; oit != all.end(); oit++){
            objPtr = *oit;
            type = objPtr->type();            
            switch(type){
            case TYPE_ROAD:
              ++rNum;
              rPtr = dynamic_cast<Road*>(objPtr);
              roads.push_back(rPtr);
              break;
            case TYPE_NODE:
              nPtr = dynamic_cast<Node*>(objPtr);
              
              //subrNumupdate
              suboit = nPtr->edges().begin();
              int count = 0;
              for ( ; suboit != nPtr->edges().end(); suboit++){
                objPtr = *suboit;
                if (objPtr->type() == TYPE_ROAD)
                  ++count;
              } //for ( ; suboit != nPtr->edges().end(); suboit++)
              if (count != 0 && count != 2)
                subrNum = subrNum + count; //1{or3{ȏroadqĂꍇZ

              nodes.push_back(nPtr);
              break;
            } //switch
          } //for ( ; oit != all.end(); oit++)
          
          printf("number of roads = %d\n", rNum);
          //printf("dI\n");

          //RoboCupPʓH / f̒PʓH ̌vZ
          parameter = (float)rNum / (float)((int)((float)subrNum+0.5)/2);
          printf("rescue road units / model road units = %f\n", parameter);

          
          extrPtr = new ExtRoad[roads.size()]; //hclassz錾
          extnPtr = new ExtNode[nodes.size()]; //hclassz錾

          //////////////////////////////////////////////////////////////////
          //extRoads
          rit = roads.begin();
          for( ; rit != roads.end() ; rit++, extrPtr++){
            rPtr = *rit;
            
            //ExtRoad
            extrPtr->set_extId(rPtr->id());
            extrPtr->setHead(time, rPtr->head());
            extrPtr->setTail(time, rPtr->tail());
            extrPtr->setWidth(time, rPtr->width());
            extrPtr->init_headBrokenAvr();
            extrPtr->init_tailBrokenAvr();
            extrPtr->set_shindo(0);
             
            ///////////////////////////////////////////////////////////////
            //roadS̍W|S̃W[ɓn,kx炤  
            //ijheadxWF(extrPtr->head())->x()
            shindo = (short int)getShindo( ((rPtr->head())->x()+(rPtr->tail())->x())/2,
              ((rPtr->head())->y()+(rPtr->tail())->y())/2,
              polyNum,
              polyPtr );
            extrPtr->set_shindo(shindo);
            //printf("shindo of road %d (%d, %d)= %d\n",extrPtr->get_extId(),
            //  ((rPtr->head())->x()+(rPtr->tail())->x())/2,
            //  ((rPtr->head())->y()+(rPtr->tail())->y())/2,
            //  extrPtr->get_shindo());
            
            //////////////////////////////////////////
            //ekẍɂroad̖{Abvf[g
            switch(shindo){
            case 1: //kxTȉ
              ++(areaPtr->areaRNum);
              break;
            case 2: //kxU
              ++((areaPtr+1)->areaRNum);
              break;
            case 3: //kxV
              ++((areaPtr+2)->areaRNum);              
              break;
            case 4: //kxV
              ++((areaPtr+3)->areaRNum);
              break;
            } //switch

            extRoads.push_back(extrPtr);

          }//( ; rit != roads.end(); rit++ extrPtr++)

          //printf("shido 1 : %d roads\n", areaPtr->areaRNum);
          //printf("shido 2 : %d roads\n", (areaPtr+1)->areaRNum);
          //printf("shido 3 : %d roads\n", (areaPtr+2)->areaRNum);
          //printf("shido 4 : %d roads\n", (areaPtr+3)->areaRNum);


          //////////////////////////////////////////////////////////////////
          //extNodes
          nit = nodes.begin();
          
          for( ; nit != nodes.end(); nit++, extnPtr++){
            nPtr = *nit;

            //ExtNodes
            extnPtr->set_Id(nPtr->id());
            extnPtr->init_brokens();
            extNodes.push_back(extnPtr);
            //printf("id of extNode = %d\n", extnPtr->get_extId());            
          }//for( ; nit != nodes.end() ; nit++ nPtr++)

          /*
          //test
          xnit = extNodes.begin();
          for ( ; xnit != extNodes.end(); xnit++){
            extnPtr = *xnit;
            printf("id of extNode = %d\n", extnPtr->get_extId());
          }
          */
            
            
          delete[]polyPtr;  //|Sp̊J
          
          printf("end of KS_CONNECT_OK %d\n", kscon);
          break; // case KS_CONNECT_OK
          //////////////////////////////////////////////////////end of case KS_CONNECT_OK

          
				case KS_COMMANDS:
          ++kscom;
          printf("KS_COMMANDS %d\n", kscom);
          
          if (kscom == 2){ //2Tڂ̂Ƃ
            commands(time, input, output, socket, to, pool, difRoads, drit, extrPtr);
            printf("time = %ld.\n", (long)time);
            printf("end of 2nd KS_COMMANDS\n");
            return 0;
          }
          printf("time = %ld.\n", (long)time);
          printf("end of 1st KS_COMMANDS\n");
          
          break; //case KS_COMMANDS

        ///////////////////////////////////////////////////////////start of KS_UPDATE
				case KS_UPDATE:
          printf("KS_UPDATE\n");
					time = input.get();
					pool.restructure(time, input);

          //////////////////////////////////////////
          //buildingobuildingsɓ         
          //printf("buildingobuildingsɓ\n");
          all = pool.objects();
          oit = all.begin();          
          for ( ; oit != all.end(); oit++){            
            objPtr = *oit;
            type = objPtr->type();       
            switch(type){
            case TYPE_BUILDING:
              bPtr = dynamic_cast<Building*>(objPtr);
              buildings.push_back(bPtr);
              break;
            } //switch
          } //( ; oit != all.end(); oit++)
          

          //////////////////////////////////////////////////////////////
          //SĂbuildingɂāA|xڑSĂextNodeɂ߂ 
          //printf("SĂbuildingɂāA|xڑSĂextNodeɂ߂\n");

          bit = buildings.begin();
          for( ; bit != buildings.end(); bit++){
            bPtr = *bit;
            entranceList = bPtr->entrances(); //Objects^noden

            //buildingɐڑĂnodeSɓ|x߂
            entit = entranceList.begin();
            for( ; ; entit++){
              if (entit == entranceList.end())
                break;

              objPtr = *entit;
              nPtr = dynamic_cast<Node*>(objPtr);

              //nodeidƈvextNodeT                            
              xnit = extNodes.begin();              
              for( ; xnit != extNodes.end() ; xnit++){
                extnPtr = *xnit;
                //printf("xnid, nid = %d, %d\n", extnPtr->get_extId(), nPtr->id());
                if(extnPtr->get_extId() == nPtr->id())
                  break;      
              } //for( ; xnit != extNodes.end() ; xnit++)              

              extnPtr->add_brokenSum(bPtr->brokenness()); //|xnodeɂ߂              
              //printf("brokenAvr of node %d = %d\n", extnPtr->get_extId(), extnPtr->get_brokenAvr());
                            
            } //for( ; ; entit++)

          } //for( ; bit != buildings.end(); bit++)
          

          ///////////////////////////////////////////////////////////////
          //SĂextRoadɂāAheadBrokenAvrtailBrokenAvr߂
          //āAkẍ悲Ƃɓ|x̘a̗[maxl̘aAbvf[g
          //printf("SĂextRoadɂāAheadBrokenAvrtailBrokenAvr߂\n");
          //printf("āAkẍ悲Ƃɓ|x̘a̗[maxl̘aAbvf[g\n");
          
          xrit = extRoads.begin();
          for( ; xrit != extRoads.end(); xrit++){
            extrPtr = *xrit;
            
            //extrPtr->head()/tail()idvextNodeThead/tailBrokenAvr
            xnit = extNodes.begin();
            for( ; xnit != extNodes.end(); xnit++){
              extnPtr = *xnit;
              if (extnPtr->get_extId() == (extrPtr->head())->id()){
                extrPtr->set_headBrokenAvr(extnPtr->get_brokenAvr());
                //printf("headBrokenAvr of road %d = %d\n", extrPtr->get_extId(), extrPtr->get_headBrokenAvr());
              }
              if (extnPtr->get_extId() == (extrPtr->tail())->id()){
                extrPtr->set_tailBrokenAvr(extnPtr->get_brokenAvr());
                //printf("tailBrokenAvr of road %d = %d\n", extrPtr->get_extId(), extrPtr->get_tailBrokenAvr());
              }
            } //for( ; xnit != extNodes.end(); xnit++)

            //kẍ悲Ƃɓ|x̕ς̗[maxl̘aAbvf[g
            switch(extrPtr->get_shindo()){
            case 1: //kxTȉ
              areaPtr->sumBroken = areaPtr->sumBroken + MAX(extrPtr->get_headBrokenAvr(), extrPtr->get_tailBrokenAvr());
              break;
            case 2: //kxU
              (areaPtr+1)->sumBroken = (areaPtr+1)->sumBroken + MAX(extrPtr->get_headBrokenAvr(), extrPtr->get_tailBrokenAvr());
              break;
            case 3: //kxV
              (areaPtr+2)->sumBroken = (areaPtr+2)->sumBroken + MAX(extrPtr->get_headBrokenAvr(), extrPtr->get_tailBrokenAvr());
              break;
            case 4: //kxV
              (areaPtr+3)->sumBroken = (areaPtr+3)->sumBroken + MAX(extrPtr->get_headBrokenAvr(), extrPtr->get_tailBrokenAvr());
              break;
            }
            //printf("sumBroken of shindo1 = %d\n", areaPtr->sumBroken);
            //printf("sumBroken of shindo2 = %d\n", (areaPtr+1)->sumBroken);
            //printf("sumBroken of shindo3 = %d\n", (areaPtr+1)->sumBroken);
            //printf("sumBroken of shindo4 = %d\n", (areaPtr+1)->sumBroken);
            
          } //for( ; xrit != extRoads.end(); xrit++)



          /**************************************************************/
          /*ekẍ̓|x̕ρAW΍߂                  */
          /**************************************************************/
          //printf("ekẍ̓|x̕ρAW΍߂\n");
          int l; //kẍ1`4ŉ񂷓Y
          ////////
          //
          for(l=1;l<=4;l++){
            if((areaPtr+l-1)->areaRNum != 0){ //road̖{0̂Ƃ͖i܂蕽ς͂Oj
              (areaPtr+l-1)->avrBroken = ((areaPtr+l-1)->sumBroken)/((areaPtr+l-1)->areaRNum);
              //cout << "avrBroken for shindo " << l << " is " << (areaPtr+l-1)->avrBroken << "\n";
              
            }
          }
          //printf("avrBroken for shindo 1 = %d\n", areaPtr->avrBroken );
          //printf("avrBroken for shindo 2 = %d\n", (areaPtr+1)->avrBroken );
          //printf("avrBroken for shindo 3 = %d\n", (areaPtr+2)->avrBroken );
          //printf("avrBroken for shindo 4 = %d\n", (areaPtr+3)->avrBroken );

          ////////////
          //W΍
          int bi; //kxl̒ɂeroad̓|xiMAX肠j
          double squaresum; //W΍邽߂(bi-bbar)^2
          for (l=1; l<=4; l++){ //kxTȉ`kx7܂
            bi = 0; 
            squaresum = 0;

            if((areaPtr+l-1)->areaRNum != 0){ //road̖{0̂Ƃ͖
              
              xrit = extRoads.begin();
              for( ; xrit != extRoads.end(); xrit++){
                extrPtr = *xrit;
                
                if (extrPtr->get_shindo() == l){ //Ăroad̐kxlƈv
                  bi = MAX(extrPtr->get_headBrokenAvr(), extrPtr->get_tailBrokenAvr());
                  squaresum = squaresum + (bi-(areaPtr+l-1)->avrBroken)*(bi-(areaPtr+l-1)->avrBroken);
                } //if
                
              } //for( ; xrit != extRoads.end(); xrit++)

              //W΍̌vZ
              (areaPtr+l-1)->hhBroken = sqrt(1/((double)(areaPtr+l-1)->areaRNum)*squaresum);
              //cout << "hhBroken for shindo " << l << " is " << (areaPtr+l-1)->hhBroken << "\n";
            } //if((areaPtr+l-1)->areaRNum != 0)
            
          } //for (l=1; l<=4; l++)
          /**************************************************************/


          /**************************************************************/
          /*ׂĂroadɑ΂ĕǕ߂                          */
          /*āAǂ̂roaddifObjsɓ           @@@@*/
          /**************************************************************/
          //printf("ׂĂroadɑ΂ĕǕ߂\n");

          xrit = extRoads.begin();
          for( ; xrit != extRoads.end(); xrit++){
            extrPtr = *xrit;
            
            extrPtr->setBlock(time, getBlock(areaPtr, extrPtr));
            cout << "blockage of road " << extrPtr->get_extId() << " = " << extrPtr->block() << "[mm]\n";

            if(extrPtr->block() != 0){
              ++brNum;
              difRoads.push_back(extrPtr); //ǂȂdifRoadsɒǉ
            }

          } //for( ; xrit != extRoads.end(); xrit++)

          printf("number of blocked roads = %d\n", brNum);

          printf("end of KS_UPDATE\n");
          break; //case KS_UPDATE
        } //switch (header)
        
        if(kscom == 2)
          break; //KS_COMMANDSxĂȂbreak
        
				input.setCursor(start);
				input.skip(size);						//size oCgXLbv
			}
		} catch(std::exception& e) {
			fprintf(stderr, "%s\n", (const char*)e.what());
		} catch(...) {
			fprintf(stderr, "error...\n");
		}
	}
  
  delete[]extrPtr;
  delete[]extnPtr;

} //main

void commands(S32& time, Input& input, Output& output, LongUDPSocket& socket, Address& to, ObjectPool& pool, ExtRoads difRoads, ExtRoads::const_iterator drit, ExtRoad* extrPtr)
{
	// KS_COMMANDS M
	time = input.get();
  
  /* timeȊOinput͎̂Ă
	Header type;
	while(type = input.get(), type != HEADER_NULL) {
		S32 size = input.get();
		Input::Cursor start = input.cursor();
		commands(time, type, input, pool);
		input.setCursor(start);
		input.skip(size);
	}
  */

	// V~[Vʂ𑗐M
  //printf("outputting\n");
	output.clear();
	output.put(SK_UPDATE);
	Output::Cursor base = output.put(~(S32)0);

  drit = difRoads.begin();
  int count = 0;
  //for( ; count <= 291 && drit != difRoads.end(); drit++, count++){
  for( ; drit != difRoads.end(); drit++){  
    extrPtr = *drit;
    output.put(TYPE_ROAD);
    //printf("outputting id = %d\n", extrPtr->get_extId());
    output.put(extrPtr->get_extId());
    output.put(PROPERTY_BLOCK);
    //printf("outputting block = %d\n", extrPtr->block());
    output.put(extrPtr->block());
    output.put(PROPERTY_REPAIR_COST);
    output.put(extrPtr->block()/100);
    output.put(PROPERTY_NULL);
  } //for( ; drit != difRoads.end(); drit++)

	pool.output(output, time);
	output.setSize(base);
	output.put(HEADER_NULL);
	socket.send(output, to);

} //void commands

