// UDPSocket.hxx
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(UDPSOCKET_HXX__INCLUDED) // {
#define UDPSOCKET_HXX__INCLUDED

#include "basic.hxx"
#include "Address.hxx"

namespace Rescue
{
	/////////////////////////////////////////////////////////////////////////
	// UDPSocket

	/** \Pbgɗ񂾉炩̃G[ */
	class SocketError : public std::runtime_error {
	public:
		SocketError(const std::string& what_arg) : runtime_error(what_arg)
		{
		}
	};
	
	/**
	* UDP/IP ɂڑǗB
	*/
	class UDPSocket
	{
	private:
		
	protected:
		/** \Pbg */
		SOCKET m_socket;
		/** O receive Ŏ󂯂bZ[W̑M */
		Address m_addressRecievedFrom;
		
	public:
		virtual ~UDPSocket();
		/** w肳ꂽ Address \PbgƂč\z */
		UDPSocket(const Address& self = Address(INADDR_ANY, 0, true)); //throw(SocketError)
		
		/** O receive Ŏ󂯂bZ[W̑M */
		const Address& addressRecievedFrom() const;

		/** to  buffer  size oCg𑗐M */
		bool send(const Address& to, const char* buffer, int size);
		bool send(const Address& to, const Byte* buffer, int size);
		/**
		* bZ[WȂ true A false ԂBempty() ̂ƂA 
		* receive  bZ[WM܂ŃubNB!empty() ̂ƂA  
		* receive ͂ɏIB
		*/
		bool empty() const;
		/**
		* bZ[WMB
		* @return		MɐꍇAMoCgBobt@
		*				ꍇ -2B̑̃G[̏ꍇ -1B
		*/
		int receive(char* buffer, int size);
		int receive(Byte* buffer, int size);

		/** \PbĝǂꂩbZ[W󂯎܂ő҂Bf[^̂\Pbg̐ԂB */
		static int wait(const std::vector<const UDPSocket*>& sockets, int ms);

	private:
		UDPSocket(const UDPSocket& source);
		UDPSocket& operator= (const UDPSocket& rhs);
		bool operator== (const UDPSocket& rhs) const;
	};
	
	/////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#ifdef NDEBUG
#  include "UDPSocket.inl"
#endif

#endif // } !defined(UDPSOCKET_HXX__INCLUDED)
