///////////////////////////////////////////////////////////////////////////////
//                  Robocup Rescue Traffic Simulator                         //
//                          ver.0.1/29/1999                                  //
//                         start at 1/6/1999                                 //
//                     Produced by Ryousuke Chiba                            //
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//                         X̏֐                                  //
///////////////////////////////////////////////////////////////////////////////

#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;
//#include "struct.h"
///////////////////////////////////////////////////////////////////////////////
const Id NP=1000000;
///////////////////////////////////////////////////////////////////////////////
// _̈ړ@Ԃ֐
int RealMap::getAccess(Id now_id,Id next_id)
{
  int con1,con2,p=0;
  SimRoads::iterator now = sim_road.find(now_id);
  SimRoads::iterator next = sim_road.find(next_id);
  SimNodes::iterator node_id;
  // E0A1Ai2
  if(now->first==next->first){
    p = 2;
  }else if(now->second.head==next->second.head){
    node_id = sim_node.find(now->second.head);
    con1 = now->second.head_connect_num;
    con2 = next->second.head_connect_num;
  }else if(now->second.head==next->second.tail){
    node_id = sim_node.find(now->second.head);
    con1 = now->second.head_connect_num;
    con2 = next->second.tail_connect_num;
  }else if(now->second.tail==next->second.head){
    node_id = sim_node.find(now->second.tail);
    con1 = now->second.tail_connect_num;
    con2 = next->second.head_connect_num;
  }else if(now->second.tail==next->second.tail){
    node_id = sim_node.find(now->second.tail);
    con1 = now->second.tail_connect_num;
    con2 = next->second.tail_connect_num;
  }else{
    // Ȃ̕sv
    return 100;
  }
  if(p==0) p = node_id->second.accessKind[con1][con2];
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ΌԂ10mȓɂ邩
int RealMap::judgeAgainist(Id k)
{
  int i,con1,con2,flag=0,p=0;
  SimCars::iterator move,loop_car;
  SimRoads::iterator now,loop_road,ag_road;
  SimNodes::iterator node_id;
  move = sim_car.find(k);
  now = sim_road.find(move->second.position);
  node_id = sim_node.find(move->second.aim[move->second.step+1]);
  if(move->second.direct==0)    con1 = now->second.head_connect_num;
  else                          con1 = now->second.tail_connect_num;
  for(i=0;i<node_id->second.connect_road_num;i++){
    if(node_id->second.accessKind[con1][i] == 2){
      con2 =i;
      flag = 1;
      break;
    }
  }
  if(flag!=1){
    for(loop_road = sim_road.begin();loop_road!=sim_road.end();loop_road++){
      if(loop_road->second.head==node_id->first && 
	 loop_road->second.head_connect_num==con2){
	ag_road = loop_road;
	break;
      }else if(loop_road->second.tail==node_id->first && 
	       loop_road->second.tail_connect_num==con2){
	ag_road = loop_road;
	break;
      }
    }
    if(ag_road->second.head == node_id->first){
      loop_car = sim_car.begin();
      while(loop_car!=sim_car.end()){
	if(loop_car->second.motion==1 && 
	   loop_car->second.position==ag_road->first && 
	   loop_car->second.positionExtra<=16*1000 && 
	   loop_car->second.direct==0){
	  p = 1;
	  break;
	}
	loop_car++;
      }
    }else if(ag_road->second.tail == node_id->first){
      loop_car = sim_car.begin();
      while(loop_car!=sim_car.end()){
	if(loop_car->second.motion==1 && 
	   loop_car->second.position==ag_road->first && 
	   ag_road->second.pointer->length()-
	   loop_car->second.positionExtra<=16*1000
	   && loop_car->second.direct==1){
	  p = 1;
	  break;
	}
	loop_car++;
      }
    }
  }
  else    p = 0;
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ĂԐ߂
int RealMap::getAliveLines(Id k,Id now_id,Id next_id)
{
  int p;
  SimCars::iterator move = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(now_id);
  SimRoads::iterator next = sim_road.find(next_id);
  if(move->second.aim[move->second.step+1]==next->second.head){
    p = next->second.linesAliveTail;
  }else{
    p = next->second.linesAliveHead;
  }
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// i]n邩ǂ
int RealMap::judgeInroad(Id k)
{
  int i,dire,alive,lines,access,p=0;
  SimCars::iterator move,last;
  SimRoads::iterator now,next;
  move = sim_car.find(k);
  now = sim_road.find(move->second.position);
  next = sim_road.find(move->second.aim[move->second.step+2]);
  if(move->second.aim[move->second.step+1]==next->second.head){
    lines = (next->second.pointer)->linesToTail();
    dire = 1;
  }else{
    lines = (next->second.pointer)->linesToHead();
    dire = 0;
  }
  alive = getAliveLines(move->first,now->first,next->first);
  //printf("lines: %ld\talive: %ld\n",lines,alive);
  // ̎̋Ȃ
  if(move->second.aim_num!=move->second.step+4){
    access = getAccess(next->first,move->second.aim[move->second.step+4]);
  }else{
    access = 2;
  }
  if(access==0){
    if(dire==0 && next->second.head_last_id[lines-1]!=NP){
      last = sim_car.find(next->second.head_last_id[lines-1]);
      if(next->second.pointer->length()-last->second.positionExtra>=4*1000){
	p=1;
      }
    }else if(dire==1 && next->second.tail_last_id[lines-1]!=NP){
      last = sim_car.find(next->second.tail_last_id[lines-1]);
      if(last->second.positionExtra >= 4*1000)                   p = 1;
    }else{
      p = 1;
    }
  }else if(access==1){
    if(dire==0 && next->second.head_last_id[lines-alive]!=NP){
      last = sim_car.find(next->second.head_last_id[lines-alive]);
      if(next->second.pointer->length()-last->second.positionExtra>=4*1000){
	p=1;
      }
    }else if(dire==1 && next->second.tail_last_id[lines-alive]!=NP){
      last = sim_car.find(next->second.tail_last_id[lines-alive]);
      if(last->second.positionExtra>=4*1000){
	p=1;
      }
    }else{
      p =1;
    }
  }else{
    for(i=0;i<alive;i++){
      if(dire==0 && next->second.head_last_id[lines-1-i]==NP){
	p = 1;
	break;
      }else if(dire==1 && next->second.tail_last_id[lines-1-i]==NP){
	p = 1;
	break;
      }else if(dire==0){
	last = sim_car.find(next->second.head_last_id[lines-1-i]);
	if(next->second.pointer->length()-last->second.positionExtra>=4*1000){
	  p = 1;
	  break;
	}
      }else{
	last = sim_car.find(next->second.tail_last_id[lines-1-i]);
	if(last->second.positionExtra >= 4*1000){
	  p = 1;
	  break;
	}
      }
    }
  }
  if(alive==0) p = 0;
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ׂԐԍ߂֐
int RealMap::getLineInroad(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int i,j=0,access,x=0,lines,alive;
  if(p->second.aim_num==p->second.step+4){
    access = 2;
  }else{
    access = getAccess(next->first,p->second.aim[p->second.step+4]);
    if(access==100) access = 2;
  }
  if(p->second.aim[p->second.step+1]==next->second.tail){
    lines = next->second.pointer->linesToHead();
    alive = next->second.linesAliveHead;
    if(access==0){
      x = lines - 1;
    }else if(access==1){
      if(alive!=0)      x = lines - alive;
      else              x = 0;
    }else{
      // ŌԐiłԐ
      SimCars::iterator last;	
      SimCars::iterator tmp;
      for(i=(lines-alive);i<lines;i++){
	if(next->second.head_last_id[i]==NP){
	  j = i;
	  break;
	}else if(i==(lines-alive)){
	  j = lines - alive;
	  last = sim_car.find(next->second.head_last_id[j]);
	}else{
	  tmp = sim_car.find(next->second.head_last_id[i]);
	  if(last->second.positionExtra>=tmp->second.positionExtra){
	    j = i;
	  }
	}
	last = sim_car.find(next->second.head_last_id[j]);
      }
      x = j;
    }
  }else{
    lines = next->second.pointer->linesToTail();
    alive = next->second.linesAliveTail;
    if(access==0){
      x = lines - 1;
    }else if(access==1){
      if(alive!=0)    x = lines - alive;
      else            x = 0;
    }else{
      // ŌԐiłԐ
      SimCars::iterator last;
      SimCars::iterator tmp;
      for(i=(lines-alive);i<lines;i++){
	if(next->second.tail_last_id[i]==NP){
	  j = i;
	  break;
	}else if(i==(lines-alive)){
	  j = lines - alive;
	  last = sim_car.find(next->second.tail_last_id[j]);
	}else{
	  tmp = sim_car.find(next->second.tail_last_id[i]);
	  if(tmp->second.positionExtra>=last->second.positionExtra){
	    j = i;
	  }
	}
	last = sim_car.find(next->second.tail_last_id[j]);
      }
      x = j;
    }
  }
  return x;
}

///////////////////////////////////////////////////////////////////////////////
