
#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;

const Id NP=1000000;

void reviseRealMap(RealMap& real_map)
{
  SimRoads::iterator p_road;
  for(p_road = real_map.sim_road.begin(); p_road != real_map.sim_road.end(); p_road++){
    p_road->second.setLinesAlive();         // linesAliveHeadlinesAliveTail̐ݒ
  }

  real_map.InitEnv();
}

///////////////////////////////////////////////////////////////////////////////
// \z
void RealMap::InitEnv()
{
  InitCar();
  InitLines();
  InitFront();
  InitRoad();
}

///////////////////////////////////////////////////////////////////////////////
// Ԃ̏
void RealMap::InitCar()
{
  SimCars::iterator p;
  SimRoads::iterator now,next,p_road;
  for(p=sim_car.begin();p!=sim_car.end();p++){
    if(p->second.motion!=1){
      p->second.speed = 0;
      printf("b");
    }else{
      p->second.flag = 0;
      p->second.between = 0;
      p->second.step = 0;
      p->second.pocket = 0;
      now = sim_road.find(p->second.position);
      if(now->second.head==p->second.aim[1])       p->second.direct = 0;
      else if(now->second.tail==p->second.aim[1])  p->second.direct = 1;
      else{
	printf("a");
	p->second.motion = 0;
      }
    }
  }
  printf("\n");
}

///////////////////////////////////////////////////////////////////////////////
// line
void RealMap::InitLines()
{
  int access,lines,alive,con;
  SimCars::iterator p;
  SimRoads::iterator now,next;
  SimNodes::iterator node_id,p_node;
  //std::vector<int>::iterator i;

  for(p=sim_car.begin();p!=sim_car.end();p++){
    if(p->second.motion==1){
      now = sim_road.find(p->second.position);
      next = sim_road.find(p->second.aim[(p->second.step)+2]);
      access = getAccess(now->first,next->first);
      if(p->second.direct==0){
	node_id=sim_node.find(now->second.head);
	con = now->second.head_connect_num;
	alive = now->second.linesAliveHead;
	lines = (now->second.pointer)->linesToHead();
	if(access==0){
	  if(node_id->second.pocketToTurnAcross.size()!=0){
	    if(node_id->second.pocketToTurnAcross[con*2]>=1 && 
	       p->second.positionExtra
	       <node_id->second.pocketToTurnAcross[con*2+1]){
	      p->second.pocket = 1;
	    }else{
	      p->second.line=lines-1;
	    }
	  }else{
	    p->second.line=lines-1;
	  }
	}
      }else{
	node_id=sim_node.find(now->second.tail);
	con = now->second.tail_connect_num;
	alive = now->second.linesAliveTail;
	lines = (now->second.pointer)->linesToTail();
	if(access==0){
	  if(node_id->second.pocketToTurnAcross.size()!=0){
	    if(node_id->second.pocketToTurnAcross[con*2]>=1 && 
	       (now->second.pointer)->length() - p->second.positionExtra
	       <node_id->second.pocketToTurnAcross[(con*2+1)]){
	      p->second.pocket = 1;
	    }else{
	      p->second.line=lines-1;
	    }
	  }else{
	    p->second.line=lines-1;
	  }
	}
      }
      if(access==1){
	if(alive!=0)	  p->second.line = lines-alive;
	else              p->second.line = lines-1;
      }else{
	if(alive!=0)  p->second.line = (int)(p->first%alive);
	else          p->second.line = 0;
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// OԂƌԁA̎Ԋ
void RealMap::InitFront()
{
  int max_back,max_front;

  SimCars::iterator p,front,k;
  SimRoads::iterator now;

  for(p=sim_car.begin();p!=sim_car.end();p++){
    if(p->second.motion==1){
      now = sim_road.find(p->second.position);
      max_front=(now->second.pointer)->length();
      max_back=(now->second.pointer)->length();
      p->second.front_id = NP;
      p->second.back_id = NP;
      if(p->second.direct==0) p->second.between = p->second.positionExtra;
      else{
	p->second.between=
	  (now->second.pointer)->length() - p->second.positionExtra;
      }
      for(front=sim_car.begin();front!=sim_car.end();front++){
	if(p->first!=front->first && front->second.motion==1 && 
	   front->second.position==p->second.position && 
	   front->second.direct==p->second.direct &&
	   front->second.line==p->second.line){
	  if(p->second.direct==0){
	    if(p->second.positionExtra > front->second.positionExtra &&
	       p->second.positionExtra-front->second.positionExtra<=max_front){
	      p->second.front_id = front->first; 
	      max_front = p->second.positionExtra-front->second.positionExtra;
	      p->second.between = max_front;
	    }else if(p->second.positionExtra < front->second.positionExtra && 
		     front->second.positionExtra-p->second.positionExtra
		     <=max_back){
	      p->second.back_id = front->first;
	      max_back=front->second.positionExtra-p->second.positionExtra;
	    }
	  }else{
	    if(p->second.positionExtra < front->second.positionExtra &&
	       front->second.positionExtra-p->second.positionExtra<=max_front){
	      p->second.front_id = front->first;
	      max_front=front->second.positionExtra-p->second.positionExtra;
	      p->second.between = max_front;
	    }else if(p->second.positionExtra > front->second.positionExtra &&
		     p->second.positionExtra-front->second.positionExtra
		     <=max_back){
	      p->second.back_id = front->first;
	      max_back = p->second.positionExtra-front->second.positionExtra;
	    }
	  }
	}
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// [h
void RealMap::InitRoad()
{
  int i,max_head[6],max_head_pocket,max_tail[6],max_tail_pocket,lines;
  SimCars::iterator p;
  SimRoads::iterator now;
  for(now=sim_road.begin();now!=sim_road.end();now++){
    for(i=0;i<6;i++){
      now->second.head_last_id[i] = NP;
      now->second.tail_last_id[i] = NP; 
      max_head[i] = 0;
      max_tail[i] = (now->second.pointer)->length();
    }
    now->second.head_pocket = NP;
    now->second.tail_pocket = NP;
    max_head_pocket = 0;
    max_tail_pocket = (now->second.pointer)->length();
    for(p=sim_car.begin();p!=sim_car.end();p++){
      if(p->second.motion==1 && p->second.position==now->first){
	if(p->second.direct==0){
	  if(p->second.pocket==1 && p->second.positionExtra>=max_head_pocket){
	    now->second.head_pocket = p->first;
	    max_head_pocket = p->second.positionExtra;
	  }else{
	    lines = (now->second.pointer)->linesToHead();
	    for(i=0;i<lines;i++){
	      if(p->second.line==i && p->second.positionExtra>=max_head[i]){
		now->second.head_last_id[i] = p->first;
		max_head[i] = p->second.positionExtra;
	      }
	    }
	  }
	}else{
	  if(p->second.pocket==1 && p->second.positionExtra<=max_tail_pocket){
	    now->second.tail_pocket = p->first;
	    max_tail_pocket = p->second.positionExtra;
	  }else{
	    lines = (now->second.pointer)->linesToTail();
	    for(i=0;i<lines;i++){
	      if(p->second.line==i && p->second.positionExtra<=max_tail[i]){
		now->second.tail_last_id[i] = p->first;
		max_tail[i] = p->second.positionExtra;
	      }
	    }
	  }
	}
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
